/*
 * DialogLieferant.java
 * eu.gronos.kostenrechner.interfaces (Kostenrechner)
 */
package eu.gronos.kostenrechner.interfaces;

import javax.swing.JDialog;

import eu.gronos.kostenrechner.controller.BeschriebeneAktion;

//Von {@link AbfrageLieferant} abgeleitetes {@link HinzufuegenDialog} (nicht nur einen 
/**
 * Interface für {@link BeschriebeneAktion}en, die einen {@link JDialog}
 * entsprechend dem Typ-Parameter aufrufen.
 *
 * @author Peter Schuster (setrok)
 * @date 29.10.2019
 *
 * @param <E> der Typ des {@link JDialog}
 */
public interface AbfrageLieferant<E extends JDialog> {
	// Kosten

	// Kosten
	/**
	 * @return gibt den {@link JDialog} zurück, den die {@link BeschriebeneAktion}
	 *         erstellt, oder <code>null</code>, wenn der gerade nicht geöffnet ist.
	 */
	public E getDialog();
}
